Package ghidra.pcode.emu.jit.gen.var

# Enum Class DirectMemoryVarGen

java.lang.Object
java.lang.Enum<DirectMemoryVarGen>
ghidra.pcode.emu.jit.gen.var.DirectMemoryVarGen

All Implemented Interfaces:
  `MemoryVarGen<JitDirectMemoryVar>`, `ValGen<JitDirectMemoryVar>`, `VarGen<JitDirectMemoryVar>`, `Serializable`, `Comparable<DirectMemoryVarGen>`, `Constable`

public enum DirectMemoryVarGen extends Enum<DirectMemoryVarGen> implements MemoryVarGen<JitDirectMemoryVar>
The generator for a direct memory variable.

This prohibits generation of code to write the variable.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

  ## Nested classes/interfaces inherited from interface ghidra.pcode.emu.jit.gen.var.VarGen

  `VarGen.BlockTransition`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `GEN`
  Singleton

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `generateVarWriteCode(JitCodeGenerator gen, JitDirectMemoryVar v, JitType type, TypeConversions.Ext ext, org.objectweb.asm.MethodVisitor rv)`
  Write a value from the stack into the given variable
  `static DirectMemoryVarGen`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static DirectMemoryVarGen[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.pcode.emu.jit.gen.var.MemoryVarGen

  `generateValInitCode, generateValReadCode`

- ## Enum Constant Details

  - ### GEN

    public static final DirectMemoryVarGen GEN
    Singleton

- ## Method Details

  - ### values

    public static DirectMemoryVarGen[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static DirectMemoryVarGen valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### generateVarWriteCode

    public void generateVarWriteCode(JitCodeGenerator gen, JitDirectMemoryVar v, JitType type, TypeConversions.Ext ext, org.objectweb.asm.MethodVisitor rv)
    Description copied from interface: `VarGen`
    Write a value from the stack into the given variable
    Specified by:
      `generateVarWriteCode` in interface `VarGen<JitDirectMemoryVar>`
    Parameters:
      `gen` - the code generator
      `v` - the variable to write
      `type` - the p-code type (which also determines the expected JVM type) of the value on the stack
      `ext` - the kind of extension to apply when adjusting from varnode size to JVM size
      `rv` - the visitor for the `run` method